detect_crypt()
{
    which cryptsetup >/dev/null 2>&1 && [ -n "`dmcryptmap $device`" ]
}

describe_crypt()
{
    echo "    cryptsetup (luks and dmcrypt)"
}

do_crypt()
{
    # Step 2: Find the crypted volume defined for this partition

    local offset
    local devnums
    local cryptdev
    local cryptsector
    local type

    echo "# $device: cryptsetup detected" 1>&2

    offset="`cryptsetup luksDump $device 2>/dev/null | awk '/^Payload offset/{print $3}'`"

    if [ -z "$offset" ]; then
        # Plain dmcrypt
        offset=0
        type=dmcrypt
    else
        type=luks
    fi

    cryptdev="`dmcryptmap $device`"

    if [ -z "$cryptdev" ]; then
        echo "! Failed to find decrypted mapper device for $device"
        exit 1;
    fi

    cryptsector="`dc -e "$sector $offset - p"`" #`"

    echo "offset $offset"
    echo "device $cryptdev crypt"
    echo "type $type"
    echo "sector $cryptsector"

    device="$cryptdev"
    sector="$cryptsector"

    return 1
}

register_mapper "crypt"
